#include <stdio.h>
#include <string.h>
#define D 40

struct socio {
       char cognome[30];
       char nome[30];
       char data[11];
       int tessera,categoria;
       };

void leggi(struct socio *ps)
{
   printf("Cognome: ");
   scanf("%s",ps->cognome);
   printf("Nome: ");
   scanf("%s",ps->nome);
   printf("Data (aaaa/mm/gg): ");
   scanf("%s",ps->data);
   printf("Numero tessera: ");
   scanf("%d",&ps->tessera);
   printf("Categoria (0..3): ");
   scanf("%d",&ps->categoria);
}


void inserimento(struct socio *V,int *pn, struct socio s)
{
     if(*pn<D)/* vettore non pieno*/
       { /* inserimento*/
         V[*pn]=s;
         (*pn)++;
       }
     else printf("Vettore pieno\n");
}

void visualizzazione(struct socio *V, int n)
{
     int categoria;
     int i;


     printf("Categoria (0..3): ");
     scanf("%d",&categoria);

     for(i=0;i<n;i++)
       if(V[i].categoria==categoria)
         printf("Cognome: %s  Nome: %s\n",V[i].cognome,V[i].nome);

}

void salvataggio(struct socio *V, int m)
{
     FILE *pf;
     int i;
     char data[11];

     printf("Data: ");
     scanf("%s",data);

     pf=fopen("soci.dat","wb");
     if(pf)
       { for(i=0;i<m;i++)
           if(strcmp(V[i].data,data)<0)
            fwrite(&V[i],sizeof(struct socio),1,pf);
         fclose(pf);
       }
    else printf("ERRORE IN SCRITTURA\n");
}

void lettura(struct socio *V, int *pn)
{
  FILE *pp;
  int i=0;
  struct socio s;

  pp=fopen("soci.dat","rb");
  if(pp)
     {  while(i<D && fread(&s,sizeof(struct socio),1,pp)>0)
         {V[i]=s;
          i++;
         }
         fclose(pp);
     }
  else printf("ERRORE IN LETTURA\n");
  *pn=i;
}

main() {
  struct socio V[D],s;
  int numero,scelta;

  numero=0;

  do{
           printf("Scegli tra:\n");
           printf("1) Inserimento\n");
           printf("2) Visualizzazione\n");
           printf("3) Salvataggio\n");
           printf("4) Lettura da file\n");
		   printf("0) fine\n");
           scanf("%d",&scelta);
           switch(scelta) {
            case 1:   leggi(&s);
                      inserimento(V,&numero,s);
                      break;
            case 2:   visualizzazione(V,numero);
                      break;
            case 3:   salvataggio(V,numero);
                      break;
            case 4:   lettura(V,&numero);
                      break;
            default:;
            }
            } while(scelta!=0);
  }












